package winterwell.jtwitter;

import java.util.Date;

/**
 * Info on your Twitter API usage - how many calls do you have to use?
 * @author daniel
 */
public final class RateLimit {
	/*
	 * We use lazy parsing for efficiency (most of these objects will never be examined).
	 */
	
	private String limit;
	private String remaining;
	private String reset;

	public int getRemaining() {
		return Integer.valueOf(remaining);
	}
	
	public Date getReset() {
		return new Date(Long.valueOf(reset));
	}
	
	public int getLimit() {
		return Integer.valueOf(limit);
	}
	
	public RateLimit(String limit, String remaining, String reset) {
		this.limit = limit;
		this.remaining=remaining;
		this.reset = reset;
	}

	@Override
	public String toString() {
		return remaining;
	}
}
